# CustomBondForce Class Reference

This class implements bonded interactions between pairs of particles. More...

`#include <CustomBondForce.h>`

Inheritance diagram for CustomBondForce:

List of all members.

## Classes

class | BondInfo
| This is an internal class used to record information about a bond.
class | BondParameterInfo
| This is an internal class used to record information about a per-bond parameter.
class | GlobalParameterInfo
| This is an internal class used to record information about a global parameter.

## Public Member Functions

| CustomBondForce (const std::string &energy)
| Create a CustomBondForce.
int | getNumBonds () const
| Get the number of bonds for which force field parameters have been defined.
int | getNumPerBondParameters () const
| Get the number of per-bond parameters that the interaction depends on.
int | getNumGlobalParameters () const
| Get the number of global parameters that the interaction depends on.
const std::string & | getEnergyFunction () const
| Get the algebraic expression that gives the interaction energy for each bond.
void | setEnergyFunction (const std::string &energy)
| Set the algebraic expression that gives the interaction energy for each bond.
int | addPerBondParameter (const std::string &name)
| Add a new per-bond parameter that the interaction may depend on.
const std::string & | getPerBondParameterName (int index) const
| Get the name of a per-bond parameter.
void | setPerBondParameterName (int index, const std::string &name)
| Set the name of a per-bond parameter.
int | addGlobalParameter (const std::string &name, double defaultValue)
| Add a new global parameter that the interaction may depend on.
const std::string & | getGlobalParameterName (int index) const
| Get the name of a global parameter.
void | setGlobalParameterName (int index, const std::string &name)
| Set the name of a global parameter.
double | getGlobalParameterDefaultValue (int index) const
| Get the default value of a global parameter.
void | setGlobalParameterDefaultValue (int index, double defaultValue)
| Set the default value of a global parameter.
int | addBond (int particle1, int particle2, const std::vector< double > &parameters)
| Add a bond term to the force field.
void | getBondParameters (int index, int &particle1, int &particle2, std::vector< double > &parameters) const
| Get the force field parameters for a bond term.
void | setBondParameters (int index, int particle1, int particle2, const std::vector< double > &parameters)
| Set the force field parameters for a bond term.
void | updateParametersInContext (Context &context)
| Update the per-bond parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements bonded interactions between pairs of particles.

Unlike HarmonicBondForce, the functional form of the interaction is completely customizable, and may involve arbitrary algebraic expressions. It may depend on the distance between particles, as well as on arbitrary global and per-bond parameters.

To use this class, create a CustomBondForce object, passing an algebraic expression to the constructor that defines the interaction energy between each pair of bonded particles. The expression may depend on r, the distance between the particles, as well as on any parameters you choose. Then call addPerBondParameter() to define per-bond parameters, and addGlobalParameter() to define global parameters. The values of per-bond parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter(). Finally, call addBond() once for each bond. After a bond has been added, you can modify its parameters by calling setBondParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomBondForce that implements a harmonic potential:

`CustomBondForce* force = new CustomBondForce("0.5*k*(r-r0)^2");`

This force depends on two parameters: the spring constant k and equilibrium distance r0. The following code defines these parameters:

``

     force->addPerBondParameter("k");
     force->addPerBondParameter("r0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

## Constructor & Destructor Documentation

CustomBondForce | ( | const std::string & | energy | ) | `[explicit]`

Create a CustomBondForce.

Parameters:

  | energy | an algebraic expression giving the interaction energy between two bonded particles as a function of r, the distance between them

## Member Function Documentation

int addBond | ( | int | particle1,
|  | int | particle2,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Add a bond term to the force field.

Parameters:

  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | parameters | the list of parameters for the new bond

Returns:
  the index of the bond that was added

int addGlobalParameter | ( | const std::string & | name,
|  | double | defaultValue |
| ) |  |  |

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

Returns:
  the index of the parameter that was added

int addPerBondParameter | ( | const std::string & | name | ) |

Add a new per-bond parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

Returns:
  the index of the parameter that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

void getBondParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | std::vector< double > & | parameters |
| ) |  |  | const

Get the force field parameters for a bond term.

Parameters:

  | index | the index of the bond for which to get parameters
  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | parameters | the list of parameters for the bond

const std::string& getEnergyFunction | ( |  | ) | const

Get the algebraic expression that gives the interaction energy for each bond.

double getGlobalParameterDefaultValue | ( | int | index | ) | const

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

Returns:
  the parameter default value

const std::string& getGlobalParameterName | ( | int | index | ) | const

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

int getNumBonds | ( |  | ) | const`[inline]`

Get the number of bonds for which force field parameters have been defined.

int getNumGlobalParameters | ( |  | ) | const`[inline]`

Get the number of global parameters that the interaction depends on.

int getNumPerBondParameters | ( |  | ) | const`[inline]`

Get the number of per-bond parameters that the interaction depends on.

const std::string& getPerBondParameterName | ( | int | index | ) | const

Get the name of a per-bond parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

void setBondParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Set the force field parameters for a bond term.

Parameters:

  | index | the index of the bond for which to set parameters
  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | parameters | the list of parameters for the bond

void setEnergyFunction | ( | const std::string & | energy | ) |

Set the algebraic expression that gives the interaction energy for each bond.

void setGlobalParameterDefaultValue | ( | int | index,
|  | double | defaultValue |
| ) |  |  |

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

void setGlobalParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void setPerBondParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a per-bond parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void updateParametersInContext | ( | Context & | context | ) |

Update the per-bond parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setBondParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-bond parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a bond cannot be changed, nor can new bonds be added.

The documentation for this class was generated from the following file:

- CustomBondForce.h